import Blender
import types

ACCENTGRAVEKEY = Blender.Draw.ACCENTGRAVEKEY
AKEY = Blender.Draw.AKEY
BACKSLASHKEY = Blender.Draw.BACKSLASHKEY
BACKSPACEKEY = Blender.Draw.BACKSPACEKEY
BKEY = Blender.Draw.BKEY
CAPSLOCKKEY = Blender.Draw.CAPSLOCKKEY
CKEY = Blender.Draw.CKEY
COMMAKEY = Blender.Draw.COMMAKEY
DELKEY = Blender.Draw.DELKEY
DKEY = Blender.Draw.DKEY
DOWNARROWKEY = Blender.Draw.DOWNARROWKEY
EIGHTKEY = Blender.Draw.EIGHTKEY
EKEY = Blender.Draw.EKEY
ENDKEY = Blender.Draw.ENDKEY
EQUALKEY = Blender.Draw.EQUALKEY
ESCKEY = Blender.Draw.ESCKEY
F10KEY = Blender.Draw.F10KEY
F11KEY = Blender.Draw.F11KEY
F12KEY = Blender.Draw.F12KEY
F1KEY = Blender.Draw.F1KEY
F2KEY = Blender.Draw.F2KEY
F3KEY = Blender.Draw.F3KEY
F4KEY = Blender.Draw.F4KEY
F5KEY = Blender.Draw.F5KEY
F6KEY = Blender.Draw.F6KEY
F7KEY = Blender.Draw.F7KEY
F8KEY = Blender.Draw.F8KEY
F9KEY = Blender.Draw.F9KEY
FIVEKEY = Blender.Draw.FIVEKEY
FKEY = Blender.Draw.FKEY
FOURKEY = Blender.Draw.FOURKEY
GKEY = Blender.Draw.GKEY
HKEY = Blender.Draw.HKEY
HOMEKEY = Blender.Draw.HOMEKEY
IKEY = Blender.Draw.IKEY
INPUTCHANGE = Blender.Draw.INPUTCHANGE
INSERTKEY = Blender.Draw.INSERTKEY
JKEY = Blender.Draw.JKEY
KEYBD = Blender.Draw.KEYBD
KKEY = Blender.Draw.KKEY
LEFTALTKEY = Blender.Draw.LEFTALTKEY
LEFTARROWKEY = Blender.Draw.LEFTARROWKEY
LEFTBRACKETKEY = Blender.Draw.LEFTBRACKETKEY
LEFTCTRLKEY = Blender.Draw.LEFTCTRLKEY
LEFTMOUSE = Blender.Draw.LEFTMOUSE
LEFTSHIFTKEY = Blender.Draw.LEFTSHIFTKEY
LINEFEEDKEY = Blender.Draw.LINEFEEDKEY
LKEY = Blender.Draw.LKEY
MIDDLEMOUSE = Blender.Draw.MIDDLEMOUSE
MINUSKEY = Blender.Draw.MINUSKEY
MKEY = Blender.Draw.MKEY
MOUSEX = Blender.Draw.MOUSEX
MOUSEY = Blender.Draw.MOUSEY
NINEKEY = Blender.Draw.NINEKEY
NKEY = Blender.Draw.NKEY
OKEY = Blender.Draw.OKEY
ONEKEY = Blender.Draw.ONEKEY
PAD0 = Blender.Draw.PAD0
PAD1 = Blender.Draw.PAD1
PAD2 = Blender.Draw.PAD2
PAD3 = Blender.Draw.PAD3
PAD4 = Blender.Draw.PAD4
PAD5 = Blender.Draw.PAD5
PAD6 = Blender.Draw.PAD6
PAD7 = Blender.Draw.PAD7
PAD8 = Blender.Draw.PAD8
PAD9 = Blender.Draw.PAD9
PADASTERKEY = Blender.Draw.PADASTERKEY
PADENTER = Blender.Draw.PADENTER
PADMINUS = Blender.Draw.PADMINUS
PADPERIOD = Blender.Draw.PADPERIOD
PADPLUSKEY = Blender.Draw.PADPLUSKEY
PADSLASHKEY = Blender.Draw.PADSLASHKEY
PAGEDOWNKEY = Blender.Draw.PAGEDOWNKEY
PAGEUPKEY = Blender.Draw.PAGEUPKEY
PAUSEKEY = Blender.Draw.PAUSEKEY
PERIODKEY = Blender.Draw.PERIODKEY
PKEY = Blender.Draw.PKEY
QFULL = Blender.Draw.QFULL
QKEY = Blender.Draw.QKEY
QUOTEKEY = Blender.Draw.QUOTEKEY
Q_FIRSTTIME = Blender.Draw.Q_FIRSTTIME
RAWKEYBD = Blender.Draw.RAWKEYBD
REDRAW = Blender.Draw.REDRAW
RETKEY = Blender.Draw.RETKEY
RIGHTALTKEY = Blender.Draw.RIGHTALTKEY
RIGHTARROWKEY = Blender.Draw.RIGHTARROWKEY
RIGHTBRACKETKEY = Blender.Draw.RIGHTBRACKETKEY
RIGHTCTRLKEY = Blender.Draw.RIGHTCTRLKEY
RIGHTMOUSE = Blender.Draw.RIGHTMOUSE
RIGHTSHIFTKEY = Blender.Draw.RIGHTSHIFTKEY
RKEY = Blender.Draw.RKEY
SEMICOLONKEY = Blender.Draw.SEMICOLONKEY
SEVENKEY = Blender.Draw.SEVENKEY
SIXKEY = Blender.Draw.SIXKEY
SKEY = Blender.Draw.SKEY
SLASHKEY = Blender.Draw.SLASHKEY
SPACEKEY = Blender.Draw.SPACEKEY
TABKEY = Blender.Draw.TABKEY
THREEKEY = Blender.Draw.THREEKEY
TIMER0 = Blender.Draw.TIMER0
TIMER1 = Blender.Draw.TIMER1
TIMER2 = Blender.Draw.TIMER2
TIMER3 = Blender.Draw.TIMER3
TKEY = Blender.Draw.TKEY
TWOKEY = Blender.Draw.TWOKEY
UKEY = Blender.Draw.UKEY
UPARROWKEY = Blender.Draw.UPARROWKEY
VKEY = Blender.Draw.VKEY
WHEELDOWNMOUSE = Blender.Draw.WHEELDOWNMOUSE
WHEELUPMOUSE = Blender.Draw.WHEELUPMOUSE
WINCLOSE = Blender.Draw.WINCLOSE
WINFREEZE = Blender.Draw.WINFREEZE
WINQUIT = Blender.Draw.WINQUIT
WINTHAW = Blender.Draw.WINTHAW
WKEY = Blender.Draw.WKEY
XKEY = Blender.Draw.XKEY
YKEY = Blender.Draw.YKEY
ZEROKEY = Blender.Draw.ZEROKEY
ZKEY = Blender.Draw.ZKEY

ICON_VISIBLE = 0
ICON_SELECTABLE = 1
ICON_RENDERABLE = 2
ICON_DROPDOWN = 3

class Buttonx:
	
	#drawXIcons = Blender.Image.Load(Blender.Get("datadir")+"/drawx_icons.tif")
	#drawXIcons.reload()
	drawXIcons = None
	
	_areaVertices = []
	
	# Dictionary value list: [ ClipX, NumStates ]
	_iconButtonDict = {
		ICON_VISIBLE: [96, 2],
		ICON_SELECTABLE: [112, 2],
		ICON_RENDERABLE: [128, 2],
		ICON_DROPDOWN: [144, 1]
	}
	
	scrollTest = None
	
	_sheets = []
	_buttons = []
	#_objects = []
	_lowestU = None
	_highestU = None
	
	def __init__(self, val):
		self.val = val
	#end __init__
	
	def processEvent(evt, val): # we only get here on a Blender.Draw.LEFTMOUSE
		#print "Process events"
		#print "have", len(Buttonx._buttons), "custom buttons"
		
		if val==1: #Button Click (as opposed to button release (i.e. val==0))
			#print "val, evt", val, evt
			
			mouseX, mouseY = Blender.Window.GetMouseCoords()
			
			#print "loop through buttons"
			
			for button in Buttonx._buttons:
				#print "check button hotspot", button
				hotspot = button._getHotspot([mouseX, mouseY])
				#print "...", hotspot
				
				if hotspot!=None:
					evt = button._onClick(hotspot)
					return (evt, val, 1)
				#end if
			#end for
			
			#print "end button loop"
		#end if
		
		return (evt, val, 0)
	#end processEvent
	
	def applyModifiers(x, y, width, height):
		if len(Buttonx._sheets)>0:
			mr = Buttonx._sheets[-1].applyModifiers(x, y, width, height)
		else:
			if Buttonx.scrollTest!=None: y+=Buttonx.scrollTest
			mr = {}
			mr["x"] = x
			mr["y"] = y
			mr["width"] = width
			mr["height"] = height
		#end if
		
		if mr!=None:
			if Buttonx._lowestU==None: Buttonx._lowestU = mr["y"]
			if Buttonx._highestU==None: Buttonx._highestU = mr["y"]
			
			if mr["y"] < Buttonx._lowestU: Buttonx._lowestU = mr["y"]
			
			if len(Buttonx._sheets)==0:
				if (mr["y"]+height) > Buttonx._highestU: Buttonx._highestU = (mr["y"]+height)
			else:
				if (mr["y"]-height) > Buttonx._highestU: Buttonx._highestU = (mr["y"]-height)
			#end if
		#end if
		
		return mr
	#end applyModifiers
	
	class ImageButton():
		
		def __init__(self, name, event, image, x, y, width, height, numStates, default, clipx=0, clipy=0, toolTip=None, callback=None):
			self.val = default
			self._config = {}
			self._config["states"] = range(0, numStates)
			
			#try:
			#	self._config["states"][default]
			#except IndexError:
			#	raise ValueError("Invalid default value: %s"%(default))
			##end try/except
			
			self._config["state"] = default
			self._config["name"] = name
			self._config["event"] = event
			self._config["image"] = image
			self._config["loc"] = [x,y]
			self._config["cliploc"] = [clipx,clipy]
			self._config["size"] = [width,height]
			
			self._config["callback"] = callback
			
			areaVertices = Buttonx._areaVertices
			
			buttonVertices = []
			buttonVertices.append(areaVertices[0]+x)
			buttonVertices.append(areaVertices[1]+y)
			buttonVertices.append(buttonVertices[0]+width)
			buttonVertices.append(buttonVertices[1]+height)
			
			self._config["vertices"] = buttonVertices
			
			self._draw()
			Buttonx._buttons.append(self)
		#end __init__
		
		def __repr__(self):
			return str(self.val)
		#end __repr__
		
		def _draw(self):
			#print "--->", self._config["event"], self._config["cliploc"][1]+(self._config["size"][1]*self._config["state"])
			
			if self._config["state"]=="":  self._config["state"] = 0
			
			Blender.BGL.glEnable( Blender.BGL.GL_BLEND )
			rc = Blender.Draw.Image(self._config["image"], self._config["loc"][0], self._config["loc"][1], 1.0, 1.0, self._config["cliploc"][0], self._config["cliploc"][1]+(self._config["size"][1]*self._config["state"]), self._config["size"][0], self._config["size"][1])
			Blender.BGL.glDisable( Blender.BGL.GL_BLEND )
			
			name = self._config["name"]
			if name!=None and len(name)>0:
				Blender.Draw.Label(name, self._config["loc"][0]+self._config["size"][0], self._config["loc"][1], Blender.Draw.GetStringWidth(name)+10, self._config["size"][0])
			#end if
			
		#end _Redraw
		
		def _getHotspot(self, coords):
			buttonVertices = self._config["vertices"]
			
			if coords[0]>=buttonVertices[0] and coords[0]<=buttonVertices[2] and coords[1]>=buttonVertices[1] and coords[1]<=buttonVertices[3]:
				return 0
			#end if
			
			return None
		#end _getHotspot
		
		def _onClick(self, hotspot):
			state = self._config["state"]
			state+=1
			
			try:
				#print "try to set state", state
				self._config["states"][state]
			except IndexError:
				#print "wrap back to zero"
				state = 0
			#end try/except
			
			self._config["state"] = state
			#self._draw()
			self.val = state
			
			evt = self._config["event"]
			
			return evt
		#end _onClick
		
	#end ImageButton
	
	class Sheet():
		
		def __init__(self, name, event, default, tooltip=None):
			self.name = name
			self.event = event
			if default<0 or default>1: default=1
			self.val = default
			
			self._config = {}
			areaVertices = Buttonx._areaVertices
							
			# vertices are relative to screen coords
			vertices = []
			if len(Buttonx._sheets)==0:
				#print "first sheet"
				vertices.append(areaVertices[0])
				vertices.append(areaVertices[3]-5-15-5)
				vertices.append(areaVertices[2])
				vertices.append(areaVertices[3])
			else:
				prevSheet = Buttonx._sheets[-1]
				
				#if prevSheet.val==1:
				#	Blender.BGL.glEnable( Blender.BGL.GL_BLEND )
				#	rc = Blender.Draw.Image(Buttonx.drawXIcons, 5, prevSheet.origin[1]-prevSheet.height-10, (prevSheet.width-10)/15.0, 1.0, 15,0, 15, 15)
				#	Blender.BGL.glDisable( Blender.BGL.GL_BLEND )
				##end if
				
				vertices.append(prevSheet.vertices[0])
				vertices.append(prevSheet.vertices[1]-prevSheet.height-5-15-5)
				vertices.append(prevSheet.vertices[2])
				vertices.append(prevSheet.vertices[1])
			#end if
			
			if len(Buttonx._sheets)==0:
				if Buttonx.scrollTest!=None: vertices[1]+=Buttonx.scrollTest
			#end if
			
			self.vertices = vertices
			self.width = vertices[2] - vertices[0]
			self.height = 0 #vertices[3] - vertices[1]
			
			hotspotVertices = []
			hotspotVertices.append(vertices[0]+5)
			hotspotVertices.append(vertices[1]+5)
			hotspotVertices.append(hotspotVertices[0] + 15)
			hotspotVertices.append(hotspotVertices[1] + 15)
			self._config["hotspot"] = hotspotVertices
			
			# origin is relative to area position
			self.origin = []
			self.origin.append(vertices[0]-areaVertices[0])
			self.origin.append(vertices[1]-areaVertices[1])
			
			self._draw()
			Buttonx._sheets.append(self)
			Buttonx._buttons.append(self)
		#end __init__
		
		def __repr__(self):
			return str(self.val)
		#end __repr__
		
		def _draw(self):
			#print Buttonx.drawXIcons
			
			SHEET_OPENCLOSE_CLIP_LOC_X = 0
			SHEET_OPENCLOSE_CLIP_LOC_Y = 0
			SHEET_DECORATION_CLIP_LOC_X = 16
			SHEET_DECORATION_CLIP_LOC_Y = 0
			
			#print "Sheet", self.name
			#print "name/x/y", self.name, self.x, self.y
			
			hotspot = self._config["hotspot"]
			
			x = self.origin[0]
			y = self.origin[1]
			
			sw = Blender.Draw.GetStringWidth(self.name)+5
			Blender.Draw.Label(self.name, x+5+16, y+5, sw, 16)
			
			#print Buttonx._areaVertices
			#print hotspot
			
			#print "draw sheet icon at", hotspot[0], hotspot[1]
			Blender.BGL.glEnable( Blender.BGL.GL_BLEND )			
			rc = Blender.Draw.Image(Buttonx.drawXIcons, x+5, y+5, 1.0, 1.0, SHEET_OPENCLOSE_CLIP_LOC_X, SHEET_OPENCLOSE_CLIP_LOC_Y+(15*self.val), 16, 16)
			rc = Blender.Draw.Image(Buttonx.drawXIcons, x+5+16+sw+5, y+5, (self.width-5-16-sw-5-10-8)/16.0, 1.0, SHEET_DECORATION_CLIP_LOC_X, SHEET_DECORATION_CLIP_LOC_Y+(16*self.val), 16, 16)
			Blender.BGL.glDisable( Blender.BGL.GL_BLEND )
			
			testValY = y+5
			if Buttonx._lowestU==None: Buttonx._lowestU = testValY
			if Buttonx._highestU==None: Buttonx._highestU = testValY
			
			if testValY < Buttonx._lowestU: Buttonx._lowestU = testValY
			if (testValY+16) > Buttonx._highestU: Buttonx._highestU = (testValY+16)
		#end _draw
		
		def _getHotspot(self, coords):
			#print "!!!! sheet hotspot vertices", self.name, self._config["hotspot"], coords
			
			buttonVertices = self._config["hotspot"]
			
			if coords[0]>=buttonVertices[0] and coords[0]<=buttonVertices[2] and coords[1]>=buttonVertices[1] and coords[1]<=buttonVertices[3]:
				return 0
			#end if
			
			return None
		#end _getHotspot
		
		def _onClick(self, hotspot):
			self.val = 1-self.val
			return self.event
		#end _onClick
		
		def applyModifiers(self, x, y, width, height):
			#print "Sheet apply modifiers: self.val:", self.val
			if self.val==0: return None
			
			th = y+height
			if th > self.height:
				self.height = th
			#end if					
			
			mr = {}
			mr["x"] = x + 5
			mr["y"] = self.origin[1] - y - height
			mr["width"] = width
			mr["height"] = height
			
			#if mr["y"]<self.y: self.y = mr["y"]
			##print "sheet y is", self.y
			##print "originY", self.originY
			##print "raw x/y", x, y
			##print "modified x/y", mr["x"], mr["y"]
			
			return mr
		#end applyModifiers
		
	#end Sheet
	
	class Callable:
 		def __init__(self, anycallable):
			self.__call__ = anycallable
	
	applyModifiers = Callable(applyModifiers)
	processEvent = Callable(processEvent)
	
#end Buttonx

####################################################################################
# Packaged Text Payload
#

drawXIconsTifText = """73 73 42 0 8 0 0 0 17 0 254 0 4 0 1 0 0 0 0 0
0 0 0 1 3 0 1 0 0 0 160 0 0 0 1 1 3 0 1 0
0 0 48 0 0 0 2 1 3 0 4 0 0 0 218 0 0 0 3 1
3 0 1 0 0 0 5 0 0 0 6 1 3 0 1 0 0 0 2 0
0 0 17 1 4 0 4 0 0 0 226 0 0 0 21 1 3 0 1 0
0 0 4 0 0 0 22 1 3 0 1 0 0 0 12 0 0 0 23 1
4 0 4 0 0 0 242 0 0 0 26 1 5 0 1 0 0 0 2 1
0 0 27 1 5 0 1 0 0 0 10 1 0 0 28 1 3 0 1 0
0 0 1 0 0 0 40 1 3 0 1 0 0 0 2 0 0 0 61 1
3 0 1 0 0 0 2 0 0 0 82 1 3 0 1 0 0 0 0 0
0 0 73 134 1 0 98 1 0 0 18 1 0 0 0 0 0 0 8 0
8 0 8 0 8 0 116 2 0 0 154 3 0 0 222 6 0 0 198 10
0 0 38 1 0 0 68 3 0 0 232 3 0 0 254 3 0 0 128 252
10 0 16 39 0 0 128 252 10 0 16 39 0 0 56 66 73 77 3 237
0 0 0 0 0 16 0 72 0 0 0 1 0 1 0 72 0 0 0 1
0 1 56 66 73 77 3 238 0 0 0 0 0 6 5 65 108 112 104 97
56 66 73 77 3 239 0 0 0 0 0 14 0 0 255 255 0 0 0 0
0 0 0 50 1 0 56 66 73 77 3 243 0 0 0 0 0 8 0 0
0 0 0 0 0 0 56 66 73 77 39 16 0 0 0 0 0 10 0 1
0 0 0 0 0 0 0 2 56 66 73 77 3 245 0 0 0 0 0 72
0 47 102 102 0 1 0 108 102 102 0 6 0 0 0 0 0 1 0 47
102 102 0 1 0 161 153 154 0 6 0 0 0 0 0 1 0 50 0 0
0 1 0 90 0 0 0 6 0 0 0 0 0 1 0 53 0 0 0 1
0 45 0 0 0 6 0 0 0 0 0 1 56 66 73 77 3 248 0 0
0 0 0 112 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255
255 255 255 255 255 255 255 255 3 232 0 0 0 0 255 255 255 255 255 255
255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 3 232 0 0
0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255
255 255 255 255 3 232 0 0 0 0 255 255 255 255 255 255 255 255 255 255
255 255 255 255 255 255 255 255 255 255 255 255 3 232 0 0 56 66 73 77
4 0 0 0 0 0 0 2 0 1 56 66 73 77 4 2 0 0 0 0
0 6 0 0 0 0 0 0 128 63 224 64 8 36 22 13 7 132 66 97
80 184 100 54 29 15 136 68 98 81 56 164 86 45 23 140 70 99 81 184
228 118 61 31 144 72 100 82 57 36 150 19 2 127 201 165 82 185 100 182
93 32 64 204 101 50 240 1 194 108 0 7 206 64 51 73 228 246 125 63
160 79 229 20 26 37 22 141 71 132 76 80 47 246 5 54 84 148 72 34
0 1 193 0 162 113 58 164 86 107 85 186 228 182 135 93 176 88 108 81
74 85 50 156 176 180 72 220 142 6 197 78 171 87 7 206 236 119 59 165
214 195 95 187 94 111 85 155 45 53 128 0 180 44 45 86 203 117 90 115
113 189 226 113 88 185 37 227 25 143 200 72 239 182 123 76 138 215 109 170
97 171 25 28 230 119 61 7 199 103 244 90 56 110 78 255 129 0 4 53
81 183 134 180 1 151 194 220 46 90 77 166 214 199 161 219 110 115 250 108
5 167 84 16 214 107 182 25 157 150 235 141 199 162 110 57 28 187 222 243
81 191 224 188 53 248 78 38 31 103 204 236 118 100 92 174 215 118 187 206
202 200 120 118 254 183 123 205 231 139 119 61 30 186 7 131 5 150 234 121
51 126 207 167 214 11 234 251 126 101 94 236 30 99 228 196 63 80 11 204
128 128 128 63 224 64 8 36 22 13 7 132 66 97 80 184 100 54 29 15
136 68 98 81 56 164 86 45 23 140 66 144 49 183 249 80 160 72 140 197
3 130 1 64 0 31 39 0 200 101 82 185 100 182 93 47 152 76 102 83
48 4 9 255 52 156 78 103 83 185 228 225 227 63 155 207 97 18 112 124
166 133 71 164 82 105 84 186 100 26 109 77 168 84 106 85 58 165 86 173
87 172 86 104 244 250 213 118 189 95 176 88 108 86 59 37 106 185 101 180
90 109 86 187 101 182 221 85 179 219 238 87 57 12 109 3 65 161 28 47
82 105 69 210 253 127 183 220 112 21 134 110 22 241 15 25 226 104 216 56
69 217 254 192 200 78 82 137 4 64 2 71 37 162 98 226 248 232 113 255
61 154 198 68 64 58 57 179 255 65 71 8 234 112 243 135 126 183 79 94
193 66 167 239 29 92 87 51 161 134 97 89 175 241 38 246 47 183 220 99
178 12 0 2 195 141 50 114 56 27 25 105 37 242 139 18 206 65 120 112
242 7 86 15 158 63 235 229 72 254 227 253 251 223 133 129 60 64 11 209
195 181 49 209 128 112 243 111 60 211 82 17 127 172 126 80 177 71 214 46
39 252 0 53 174 255 109 99 98 132 182 109 170 40 40 64 128 1 127 3
191 171 123 116 222 55 201 107 128 153 150 144 140 4 0 9 144 172 18 139
56 76 139 140 88 37 64 132 60 0 30 17 8 0 228 185 108 187 157 4
195 46 34 13 13 161 240 32 160 131 197 144 122 46 68 70 135 249 75 27
128 0 20 116 133 169 238 249 250 0 12 82 8 0 57 200 144 186 42 244
159 231 100 148 0 2 146 106 106 129 72 201 91 222 248 190 111 170 74 135
12 146 202 22 78 75 128 3 240 19 191 77 114 200 255 161 144 10 37 23
32 240 57 127 40 172 176 91 122 18 38 71 92 228 0 77 243 98 29 8
150 135 249 205 61 161 227 52 253 59 33 177 75 138 227 162 208 240 32 131
196 39 132 70 229 57 140 194 251 64 163 142 156 88 139 68 148 108 78 139
16 84 201 254 86 83 128 0 227 79 128 4 5 68 135 131 53 40 0 122
85 0 4 178 50 60 139 213 0 134 73 7 117 100 0 31 117 168 0 11
215 18 123 76 156 74 111 145 98 0 74 200 125 87 45 203 178 252 194 254
76 104 26 37 51 34 51 68 213 87 205 172 52 223 56 206 115 170 67 60
79 83 226 36 115 219 128 3 177 104 32 212 20 89 67 68 17 18 21 114
33 84 77 23 18 185 177 149 195 72 195 84 34 19 116 32 183 82 21 74
196 215 114 18 66 95 135 249 85 127 128 4 46 4 0 13 152 40 0 80
225 0 5 248 66 0 6 222 28 0 3 216 136 0 116 226 128 0 243 139
128 4 110 52 0 26 152 237 192 132 201 18 81 217 93 0 17 240 0 12
101 21 214 62 134 74 102 206 92 131 216 217 113 178 131 216 104 48 99 155
128 3 94 117 47 63 47 222 86 164 204 136 125 152 132 77 8 53 159 101
168 10 212 101 55 65 169 132 228 117 206 141 238 127 108 79 103 50 39 110
28 246 243 62 186 222 14 37 199 15 160 215 85 232 132 94 200 45 241 118
209 236 110 187 65 195 136 54 198 133 236 168 38 207 71 57 232 110 110 24
159 226 214 244 0 9 123 232 0 36 240 0 0 75 193 225 184 122 12 42
113 0 5 124 0 20 220 104 0 91 242 0 1 137 201 128 2 119 44 0
13 188 205 161 36 98 135 78 72 124 244 0 3 102 0 5 221 46 84 150
229 185 122 13 99 14 157 104 0 50 246 8 157 141 159 44 136 8 128 63
224 64 8 36 22 13 7 132 60 97 79 248 68 16 161 15 0 47 226 64
24 108 86 14 65 140 67 34 209 184 228 118 61 6 137 47 226 144 86 108
149 254 36 148 71 229 80 103 92 180 1 40 18 72 229 112 133 164 213 254
230 156 76 220 243 176 1 254 125 50 153 193 144 52 55 251 2 140 0 88
82 64 1 10 100 205 225 79 139 57 28 13 128 0 112 64 40 0 3 235
84 10 21 18 140 192 164 82 160 212 192 132 122 158 240 131 212 170 149 106
197 104 31 92 142 10 174 79 244 5 212 0 197 188 88 86 17 96 69 244
0 4 192 0 17 56 48 2 23 12 0 22 226 64 9 172 101 194 130 1
200 63 219 89 48 0 155 44 0 92 102 64 4 140 228 90 4 255 199 76
194 58 55 251 103 76 0 19 234 96 231 77 96 0 203 175 153 234 68 224
7 126 215 67 65 220 110 96 185 253 212 26 20 241 127 195 202 16 121 14
223 123 199 228 71 228 172 217 60 167 147 13 150 186 229 242 142 52 126 106
180 155 206 101 115 183 60 246 127 200 161 160 104 180 122 77 238 199 77 138
217 227 214 170 173 94 179 91 138 248 124 118 15 44 90 201 7 245 69 125
150 207 125 190 86 73 192 7 249 77 1 128 7 196 12 0 30 176 72 0
34 193 128 1 119 7 128 7 244 36 0 10 240 171 48 205 8 112 200 0
69 67 142 170 102 200 0 40 210 16 111 68 128 0 69 19 128 12 252 60
220 180 96 139 74 211 182 64 0 123 25 160 224 244 108 0 15 209 200 0
54 71 128 0 101 31 128 3 20 132 212 53 77 169 223 21 185 242 74 8
222 57 13 251 130 136 56 178 84 165 41 162 206 91 154 18 74 136 35 162
233 166 46 67 174 236 156 201 210 120 159 15 242 66 54 249 43 235 211 236
166 191 41 83 246 247 45 208 244 208 242 44 77 196 222 182 190 14 57 23
61 159 230 81 152 102 0 6 193 172 107 0 7 233 250 126 69 40 40 4
0 128 64 0 47 71 128 1 165 37 13 195 178 204 64 207 180 16 1 38
127 141 212 232 0 91 212 0 0 147 81 197 40 20 204 143 69 177 20 101
26 32 199 109 92 0 80 116 34 42 10 214 128 1 137 91 200 141 156 141
83 203 45 204 153 36 163 2 9 255 40 215 182 44 149 43 38 21 236 182
152 87 136 108 190 156 76 46 220 198 239 184 243 155 233 58 202 115 187 251
57 40 130 160 160 36 32 239 226 58 246 32 207 228 227 44 146 4 129 34
127 159 7 185 238 130 36 99 197 229 102 216 200 45 46 106 95 0 0 89
125 212 173 4 149 84 198 97 234 61 87 29 169 157 98 218 54 215 172 179
95 225 88 110 28 149 217 14 116 169 101 186 146 242 109 104 76 78 236 201
122 32 239 149 189 112 97 247 52 242 143 201 200 53 200 142 92 72 45 207
135 229 142 121 35 151 159 227 134 100 0 16 121 168 0 62 103 24 226 43
84 225 245 222 90 231 225 153 254 133 150 226 50 196 179 138 75 174 61 158
237 37 78 227 189 50 201 168 94 135 149 100 109 214 74 142 101 122 158 181
173 235 154 237 139 160 235 219 11 147 162 217 73 117 153 139 59 24 197 165
141 90 155 22 221 183 238 27 142 229 185 161 27 6 233 187 161 27 38 143
179 98 186 86 47 166 35 250 118 55 188 112 156 47 13 195 241 8 246 237
196 238 91 214 39 190 105 45 238 151 104 233 182 158 161 198 115 28 207 53
177 26 166 137 147 85 94 161 88 94 27 212 252 95 55 176 241 210 158 145
157 32 188 158 51 167 245 136 35 229 161 102 67 133 183 211 247 29 204 169
206 243 233 89 88 88 23 0 6 62 153 244 93 34 87 211 119 90 215 83
41 117 123 68 193 215 240 118 170 188 163 222 164 161 32 68 61 179 195 253
233 60 72 239 163 228 185 3 71 196 127 147 31 47 98 228 139 31 79 65
99 21 31 106 129 222 125 104 71 127 224 162 190 26 59 226 244 168 31 193
177 121 114 87 154 223 155 75 128 35 206 9 182 155 165 172 154 146 202 218
107 36 121 217 144 84 210 71 66 4 17 32 239 125 253 145 224 235 5 199
250 18 31 192 0 70 193 215 206 110 95 72 88 31 239 180 84 65 242 27
8 97 27 238 32 207 192 138 191 50 102 253 136 107 248 37 100 4 128 63
224 64 8 36 22 13 5 120 194 95 240 96 124 52 3 7 136 68 98 81
56 164 86 45 23 140 69 217 177 183 248 146 61 25 144 65 29 114 48 4
120 73 15 144 196 22 146 183 251 154 93 33 115 204 64 7 249 164 162 83
6 64 206 95 236 9 224 1 97 63 155 198 28 142 6 192 0 56 32 20
0 33 160 249 180 78 114 129 157 207 96 211 245 132 92 161 87 131 213 41
80 234 13 118 189 95 136 28 44 79 244 133 148 2 114 180 63 209 214 186
109 130 44 88 184 63 213 23 59 108 84 247 119 133 196 80 183 176 13 192
177 114 186 65 154 173 22 77 230 8 172 88 46 45 197 66 129 34 14 43
23 141 238 177 72 22 26 41 9 120 229 162 84 188 157 187 61 159 140 198
217 177 216 254 130 13 35 117 201 99 217 217 4 173 105 45 151 200 38 46
121 156 214 193 79 168 176 39 212 13 52 22 135 69 163 210 115 145 109 196
243 117 90 160 239 232 212 138 221 51 123 207 231 158 186 79 244 55 86 154
124 236 63 208 157 189 102 126 253 128 84 119 98 23 115 222 106 11 123 66
223 110 55 63 14 11 8 255 196 98 186 24 204 118 67 37 32 202 197 243
30 104 199 15 160 255 179 205 19 72 18 63 237 67 84 147 172 13 115 96
115 38 9 146 104 63 188 72 187 138 158 185 14 123 148 224 185 172 236 38
227 183 140 252 46 230 63 208 4 68 144 141 209 41 254 73 69 12 232 207
21 159 228 204 93 8 168 46 251 217 24 32 175 35 44 9 199 0 2 208
57 61 75 252 102 247 48 177 26 12 251 70 136 35 242 139 63 109 4 66
137 201 50 18 189 37 192 73 52 10 146 36 210 42 39 5 37 208 99 101
7 54 202 252 54 221 170 174 132 62 225 43 136 140 191 10 179 211 28 50
139 8 19 105 254 25 6 65 152 0 181 145 178 178 64 66 16 164 33 254
62 15 99 228 236 136 142 180 9 254 69 208 144 141 2 58 208 116 43 65
25 48 46 125 24 246 160 172 28 131 39 0 18 35 240 129 201 8 82 130
171 138 8 153 127 79 179 162 13 68 254 82 136 197 62 95 169 178 139 74
231 192 210 172 18 150 75 48 107 105 7 207 232 132 207 14 183 179 84 150
156 39 78 52 192 211 87 83 42 48 29 88 135 248 145 99 128 3 245 149
90 160 226 176 174 43 31 246 32 118 0 14 3 120 223 102 32 195 101 180
127 146 150 232 2 52 92 7 249 49 113 128 35 109 204 127 129 87 72 0
121 221 128 1 45 119 219 8 45 31 120 162 151 156 129 82 58 20 178 51
35 162 178 106 41 78 83 213 5 75 129 162 53 84 8 232 85 173 91 64
77 97 151 194 10 217 182 176 131 65 91 204 48 178 136 229 204 142 116 205
94 194 149 194 221 96 227 72 194 214 71 159 233 89 102 0 0 89 72 0
33 136 66 24 0 60 143 67 204 52 65 144 71 249 170 105 154 128 0 93
157 128 14 196 252 208 80 231 249 243 161 128 0 38 141 57 173 139 16 224
178 44 206 133 237 71 61 116 106 9 73 62 12 75 254 250 82 172 140 173
126 50 244 210 11 128 34 85 61 233 130 68 87 242 221 132 193 17 19 112
137 86 142 134 40 255 228 16 142 222 228 226 240 197 118 155 208 132 97 254
118 29 167 96 0 103 153 198 114 38 0 128 32 16 0 22 133 161 96 0
8 241 128 3 201 177 162 67 47 36 127 147 124 170 155 165 105 132 128 3
204 44 188 213 23 168 210 13 238 159 169 189 232 51 226 197 177 172 126 181
75 225 200 141 68 32 178 219 22 201 217 173 219 50 65 180 114 29 162 83
185 226 206 4 65 97 41 201 214 176 131 67 8 179 149 226 119 249 15 117
229 162 81 179 208 0 142 126 137 254 70 250 157 202 9 209 180 222 198 168
137 116 233 7 134 136 223 72 198 185 230 124 157 153 185 243 245 168 61 93
242 224 109 199 191 39 110 222 5 50 204 160 222 58 43 226 160 187 191 217
253 160 163 95 252 63 196 172 1 122 196 28 239 170 84 126 164 93 41 21
123 164 69 247 145 55 194 69 223 27 252 130 80 78 10 36 231 108 217 31
209 33 130 228 66 12 193 88 61 7 205 235 219 35 46 158 6 145 104 30
69 160 140 32 133 80 174 22 66 216 93 11 225 132 31 132 73 58 19 145
88 83 12 97 196 57 135 80 238 30 67 216 113 12 210 20 53 34 132 4"""

#
# Packaged Text Payload
####################################################################################

def Exit():
	return Blender.Draw.Exit()
#end Exit

def BeginAlign():
	return Blender.Draw.BeginAlign()
#end BeginAlign

def EndAlign():
	return Blender.Draw.EndAlign()
#end EndAlign

def UIBlock(draw, mouse_exit=1):
	return Blender.Draw.UIBlock(draw, mouse_exit)
#end UIBlock

def Redraw(after=0):
	return Blender.Draw.Redraw(after)
#end Redraw

def Draw():
	return Blender.Draw.Draw()
#end Redraw

def Create(val):
	return Buttonx(val)
#end Create

def PupMenu(name, maxrow=None):
	if maxrow!=None:
		return Blender.Draw.PupMenu(name, maxrow)
	else:
		return Blender.Draw.PupMenu(name)
	#end if
#end

def PupTreeMenu(menu):
	return Blender.Draw.PupTreeMenu(menu)
#end

def PupIntInput(text, default, min, max):
	return Blender.Draw.PupIntInput(text, default, min, max)
#end

def PupFloatInput(text, default, min, max, clickStep, floatLen):
	return Blender.Draw.PupFloatInput(text, default, min, max, clickStep, floatLen)
#end

def PupStrInput(text, default, max=20):
	return Blender.Draw.PupStrInput(text, default, max)
#end

def PupBlock(title, sequence):
	return Blender.Draw.PupBlock(title, sequence)
#end

def Sheet(name, event, default, tooltip=None):
	#coords = Buttonx.applyModifiers()
	#if coords==None: return
	##x+=coords[0]
	##y+=coords[1]
	
	#print "GUI says draw a sheet", name
	
	return Buttonx.Sheet(name, event, default, tooltip)
#end Sheet

def Checkbox(name, event, x, y, width, height, default=0, toolTip=None, callback=None):
	default = valueHandler(default)
	if type(default)==type([]): default = 2
	
	mr = Buttonx.applyModifiers(x, y, width, height)
	if mr==None: return Create(default)
	
	x = mr["x"]
	y = mr["y"]
	width = mr["width"]
	height = mr["height"]
	
	return Buttonx.ImageButton(name, event, Buttonx.drawXIcons, x, y, width, height, 2, default, 64, 0, toolTip, callback)

#end Checkbox

def Radio(name, event, x, y, width, height, default=0, toolTip=None, callback=None):
	default = valueHandler(default)
	if type(default)==type([]): default = 2
		
	mr = Buttonx.applyModifiers(x, y, width, height)
	if mr==None: return Create(default)
	
	x = mr["x"]
	y = mr["y"]
	width = mr["width"]
	height = mr["height"]
	
	return Buttonx.ImageButton(name, event, Buttonx.drawXIcons, x, y, width, height, 2, default, 80, 0, toolTip, callback)

#end Checkbox

def IconButton(name, event, icon, x, y, width, height, default=0, toolTip=None, callback=None):
	try:
		config = Buttonx._iconButtonDict[icon]
	except KeyError:
		raise ValueError("Invalid Icon Reference")
	#end try/except
	
	mr = Buttonx.applyModifiers(x, y, width, height)
	if mr==None: return Create(default)
	
	x = mr["x"]
	y = mr["y"]
	width = mr["width"]
	height = mr["height"]
	
	return Buttonx.ImageButton(name, event, Buttonx.drawXIcons, x, y, width, height, config[1], default, config[0], 0, toolTip, callback)

#end IconButton

def ImageButton(name, event, image, x, y, width, height, numStates=2, default=0, clipx=0, clipy=0, toolTip=None, callback=None):
	mr = Buttonx.applyModifiers(x, y, width, height)
	if mr==None: return Create(default)
	
	x = mr["x"]
	y = mr["y"]
	width = mr["width"]
	height = mr["height"]
	
	return Buttonx.ImageButton(name, event, image, x, y, width, height, numStates, default, clipx, clipy, toolTip, callback)

#end ImageButton

def PushButton(name, event, x, y, width, height, tooltip=None, callback=None):
	# Actual X, Y passed to Blender's Draw function may be different (Collapsable sheets, scrolling, ...)
	mr = Buttonx.applyModifiers(x, y, width, height)
	if mr==None: return Create(0)
	
	x = mr["x"]
	y = mr["y"]
	width = mr["width"]
	height = mr["height"]
	
	if tooltip!=None and callback!=None:
		rc = Blender.Draw.PushButton(name, event, x, y, width, height, tooltip, callback)
	elif tooltip!=None:
		rc = Blender.Draw.PushButton(name, event, x, y, width, height, tooltip)
	else:
		rc = Blender.Draw.PushButton(name, event, x, y, width, height)
	#end if
	
	return rc
#end PushButton

def Menu(name, event, x, y, width, height, default, tooltip=None, callback=None):		
	mr = Buttonx.applyModifiers(x, y, width, height)
	if mr==None: return Create(default)
	
	x = mr["x"]
	y = mr["y"]
	width = mr["width"]
	height = mr["height"]
	
	if tooltip!=None and callback!=None:
		rc = Blender.Draw.Menu(name, event, x, y, width, height, default, tooltip, callback)
	elif tooltip!=None:
		rc = Blender.Draw.Menu(name, event, x, y, width, height, default, tooltip)
	else:
		rc = Blender.Draw.Menu(name, event, x, y, width, height, default)
	#end if
	
	return rc
#end Menu

def Toggle(name, event, x, y, width, height, default, tooltip=None, callback=None):
	default = valueHandler(default)
	if type(default)==type([]): default = 2
	
	mr = Buttonx.applyModifiers(x, y, width, height)
	if mr==None: return Create(default)
	
	x = mr["x"]
	y = mr["y"]
	width = mr["width"]
	height = mr["height"]
	
	if default!=0 and default!=1:
		name = "-"+name+"-"
	#end if
	
	if tooltip!=None and callback!=None:
		rc = Blender.Draw.Toggle(name, event, x, y, width, height, default, tooltip, callback)
	elif tooltip!=None:
		rc = Blender.Draw.Toggle(name, event, x, y, width, height, default, tooltip)
	else:
		rc = Blender.Draw.Toggle(name, event, x, y, width, height, default)
	#end if
	
	"""if default!=0 and default!=1:
		sw = Blender.Draw.GetStringWidth(name)
		tx = x+(width/2)-(sw/2)
		ty = int(y+(height/2.0))-1
		t = "-"*len(name)
		
		Blender.BGL.glColor3f(1.0,1.0,1.0)
		Blender.BGL.glRasterPos2i(tx, ty)
		Blender.Draw.Text(t)
		
		#Blender.Draw.Label(t, tx, ty, sw, 1)
	#end if"""
	
	
	return rc
#end Toggle

def Slider(name, event, x, y, width, height, initial, min, max, realtime=1, tooltip=None, callback=None):
	mr = Buttonx.applyModifiers(x, y, width, height)
	if mr==None: return Create(initial)
	
	x = mr["x"]
	y = mr["y"]
	width = mr["width"]
	height = mr["height"]
	
	if tooltip!=None and callback!=None:
		rc = Blender.Draw.Slider(name, event, x, y, width, height, initial, min, max, realtime, tooltip, callback)
	elif tooltip!=None:
		rc = Blender.Draw.Sider(name, event, x, y, width, height, initial, min, max, realtime, tooltip)
	else:
		rc = Blender.Draw.Slider(name, event, x, y, width, height, initial, min, max, realtime)
	#end if
	
	return rc
#end Slider

def ColorPicker(event, x, y, width, height, initial, tooltip=None, callback=None):
	mr = Buttonx.applyModifiers(x, y, width, height)
	if mr==None: return Create(initial)
	
	x = mr["x"]
	y = mr["y"]
	width = mr["width"]
	height = mr["height"]
	
	if tooltip!=None and callback!=None:
		rc = Blender.Draw.ColorPicker(event, x, y, width, height, initial, tooltip, callback)
	elif tooltip!=None:
		rc = Blender.Draw.ColorPicker(event, x, y, width, height, initial, tooltip)
	else:
		rc = Blender.Draw.ColorPicker(event, x, y, width, height, initial)
	#end if
	
	return rc
#end ColorPicker

def Normal(event, x, y, width, height, initial, tooltip=None, callback=None):
	mr = Buttonx.applyModifiers(x, y, width, height)
	if mr==None: return Create(initial)
	
	x = mr["x"]
	y = mr["y"]
	width = mr["width"]
	height = mr["height"]
	
	if tooltip!=None and callback!=None:
		rc = Blender.Draw.Normal(event, x, y, width, height, initial, tooltip, callback)
	elif tooltip!=None:
		rc = Blender.Draw.Normal(event, x, y, width, height, initial, tooltip)
	else:
		rc = Blender.Draw.Normal(event, x, y, width, height, initial)
	#end if
	
	return rc
#end Normal

def Number(name, event, x, y, width, height, initial, min, max, tooltip=None, callback=None):
	initial = valueHandler(initial)
	if type(initial)==type([]): 
		initial = 0.0
		multi = True
	else:
		multi = False
	#end if
	
	mr = Buttonx.applyModifiers(x, y, width, height)
	if mr==None: return Create(initial)
	
	x = mr["x"]
	y = mr["y"]
	width = mr["width"]
	height = mr["height"]
	
	if tooltip!=None and callback!=None:
		rc = Blender.Draw.Number(name, event, x, y, width, height, initial, min, max, tooltip, callback)
	elif tooltip!=None:
		rc = Blender.Draw.Number(name, event, x, y, width, height, initial, min, max, tooltip)
	else:
		rc = Blender.Draw.Number(name, event, x, y, width, height, initial, min, max)
	#end if
	
	if multi:
		s = "-"+name+": "+str(initial)+"-"
		sw = Blender.Draw.GetStringWidth(s)
		tx = x+(width/2)-(sw/2)
		ty = int(y+(height/2.0))-1
		t = "-"*len(s)
		
		Blender.Draw.Label(t, tx, ty, sw, 1)
	#end if
	
	return rc
#end Number

def String(name, event, x, y, width, height, initial, length, tooltip=None, callback=None):
	mr = Buttonx.applyModifiers(x, y, width, height)
	if mr==None: return Create(initial)
	
	x = mr["x"]
	y = mr["y"]
	width = mr["width"]
	height = mr["height"]
	
	if tooltip!=None and callback!=None:
		rc = Blender.Draw.String(name, event, x, y, width, height, initial, length, tooltip, callback)
	elif tooltip!=None:
		rc = Blender.Draw.String(name, event, x, y, width, height, initial, length, tooltip)
	else:
		rc = Blender.Draw.String(name, event, x, y, width, height, initial, length)
	#end if
	
	return rc
#end String

def GetStringWidth(string, fontsize="normal"):
	return Blender.Draw.GetStringWidth(string, fontsize)
#end GetStringWidth

def Text(string, fontsize="normal"):
	return Blender.Draw.Text(string, fontsize)
#end Text

def Label(string, x, y, width, height):
	mr = Buttonx.applyModifiers(x, y, width, height)
	if mr==None: return Create(0)
	
	x = mr["x"]
	y = mr["y"]
	width = mr["width"]
	height = mr["height"]
	
	rc = Blender.Draw.Label(string, x, y, width, height)
			
	return rc
#end Label

def Image(image, x, y, zoomx=1.0, zoomy=1.0, clipx=0, clipy=0, clipw=-1, cliph=-1):
	mr = Buttonx.applyModifiers(x, y, width, height)
	if mr==None: return Create(0)
	
	x = mr["x"]
	y = mr["y"]
	width = mr["width"]
	height = mr["height"]
	
	rc = Blender.Draw.Image(image, x, y, zoomx, zoomy, clipx, clipy, clipw, cliph)
			
	return rc
#end Image

def valueHandler(value):
	if type(value)==type([]):
		d = {}
		for i in set(value):
			d[i] = value.count(i)
		#end for
		
		if len(d)==0:
			value = 0
		elif len(d)==1:
			value = value[0]
		#end if
	#end if
	
	return value
	
#end valueHandler

def Register(guiCB, eventCB, buttonEventCB):
		
	def guiCallbackHook():
		Buttonx._sheets = []
		Buttonx._buttons = []
		Buttonx._lowestU = None
		Buttonx._highestU = None
		Buttonx._atTop = True
		Buttonx._atBottom = True
		
		theme = Blender.Window.Theme.Get()[0]
		tsp = theme.get(Blender.Window.Types.BUTS)
		Blender.BGL.glClearColor(tsp.back[0]/255.0, tsp.back[1]/255.0, tsp.back[2]/255.0, 0)
		Blender.BGL.glClear(Blender.BGL.GL_COLOR_BUFFER_BIT)
		
		areaID = Blender.Window.GetAreaID()
		for area in Blender.Window.GetScreenInfo():
			if area["id"]==areaID:
				_areaVertices = area["vertices"]
				Buttonx._areaVertices = _areaVertices
				break
			#end if
		#end for
		#print "_areaVertices", _areaVertices
		
		dataDir = Blender.Get("udatadir")
		if dataDir==None:
			dataDir = Blender.Get("datadir")
			if dataDir==None:
				dataDir = Blender.Get("homedir")
				if dataDir==None:
					print
					print "DrawX:", "User data directory comes back as:", Blender.Get("udatadir")
					print "DrawX:", "Blender data directory comes back as:", Blender.Get("datadir")
					print "DrawX:", "Blender home directory comes back as:", Blender.Get("homedir")
					print "DrawX:", "Likely cause is a problem with your Blender install."
					print "DrawX:", "ABEND: DrawX terminating.  Dependant scripts will not function."
					
					return
				#end if
			#end if
		#end if
		
		drawXIconsTif = str(dataDir)+"\\drawx_icons.tif"
		
		try:
			Buttonx.drawXIcons = Blender.Image.Load(drawXIconsTif)
		except IOError:
			print
			if dataDir == Blender.Get("homedir"):
				print "DrawX:", "Writing icon file to Blender home directory."
				print "DrawX:", "Suggest fixing your Blender install."
				print "DrawX:", "Either 'datadir' reference or 'udatadir' reference should have been set at install time."
			#end if
			
			print "DrawX:", "Can't read DrawX icon file at: ", drawXIconsTif
			print "DrawX:", "Attempting to re-create: ", drawXIconsTif
			
			fh = open(drawXIconsTif, "wb")
			try:
				lineList = drawXIconsTifText.split("\n")
				for line in lineList:
					itemList = line.split(" ")
					
					for item in itemList:
						fh.write(chr(int(item.strip())))
					#end for
				#end for
			finally:
				print "DrawX:", "File written, closing handle and trying to open again."
				fh.close()
				Buttonx.drawXIcons = Blender.Image.Load(drawXIconsTif)
				print "DrawX:", "Image loaded:", drawXIconsTif
			#end try/finally				
		#end try/except
		
		Buttonx.drawXIcons.reload()
	
		guiCB()
		
		Blender.BGL.glEnable( Blender.BGL.GL_BLEND )
		
		height = _areaVertices[3] - _areaVertices[1]
		high = Buttonx._highestU
		low = Buttonx._lowestU
		heightUI = high - low
		
		#print "height of ui", heightUI
		#print "height of area", height
		#print "highest", high
		#print "lowest", low
		
		if heightUI<=height:
			Buttonx.scrollTest = None
		else:
			if Buttonx.scrollTest==None: Buttonx.scrollTest = 0
			
			x = _areaVertices[2]-_areaVertices[0] - 16
			y = 0
			rc = Blender.Draw.Image(Buttonx.drawXIcons, x, y, 1.0, 1.0, 32, 0, 16, 8)
			
			y = 8
			scaleY = (height-8-8)/16.0
			rc = Blender.Draw.Image(Buttonx.drawXIcons, x, y, 1.0, scaleY, 32, 8, 16, 16)
			
			y = height - 8
			rc = Blender.Draw.Image(Buttonx.drawXIcons, x, y, 1.0, 1.0, 32, 24, 16, 8)
			
			if low<0:
				Buttonx._atBottom = False
				
				below = -low
				by = int(float(below)/heightUI*height)
			else:
				by = 0
			#end if
			rc = Blender.Draw.Image(Buttonx.drawXIcons, x, by, 1.0, 1.0, 48, 0, 16, 8)
			
			if high>height:
				Buttonx._atTop = False
				
				above = high - height
				ty = height - int(float(above)/heightUI*height) - 8
			else:
				ty = height - 8	
			#end if
			rc = Blender.Draw.Image(Buttonx.drawXIcons, x, ty, 1.0, 1.0, 48, 24, 16, 8)
			
			sliderMidHeight = ty-by-8
			scaleY = sliderMidHeight/16.0
			rc = Blender.Draw.Image(Buttonx.drawXIcons, x, by+8, 1.0, scaleY, 48, 8, 16, 16)
		#end if
		
		Blender.BGL.glDisable( Blender.BGL.GL_BLEND )
	#end guiCallbackHook
	
	def eventCallbackHook(evt, val):
		val2 = 0
		needRedraw = False
		
		if Buttonx.scrollTest!=None:
			if evt in [Blender.Draw.DOWNARROWKEY, Blender.Draw.WHEELDOWNMOUSE] and val:
				if not Buttonx._atBottom:
					Buttonx.scrollTest+=20
					needRedraw = True
				#end if
			elif evt in [Blender.Draw.UPARROWKEY, Blender.Draw.WHEELUPMOUSE] and val:
				if not Buttonx._atTop:
					Buttonx.scrollTest-=20
					needRedraw = True
				#end if
			#end if
		#end if
		
		if evt==Blender.Draw.RIGHTMOUSE and val==1:
			menuStr = "Draw%t|Horizonal%x0|Vertical%x1|%l|Exit%x2"
			rc = Blender.Draw.PupMenu(menuStr)
			if rc==2:
				Blender.Draw.Exit()
				return
			#end if
		elif evt==Blender.Draw.LEFTMOUSE:
			evt, val, val2 = Buttonx.processEvent(evt, val)
		#end if:
				
		if val2:
			buttonEventCB(evt)
		else:
			eventCB(evt, val)
		#end if
		
		if needRedraw:
			Blender.Draw.Redraw()
		#end if
	#end guiCallbackHook

	return Blender.Draw.Register(guiCallbackHook, eventCallbackHook, buttonEventCB)
	
#end Register

Button = PushButton
